import { registerMicroApps, setDefaultMountApp, initGlobalState, start } from 'qiankun';

const state = { a: 1, b: 2 };

// 初始化 state
const actions = initGlobalState(state);

actions.onGlobalStateChange((state, prev) => {
  // state: 变更后的状态; prev 变更前的状态
  console.info(state, prev);
});
actions.setGlobalState({ a: 1, b: 2, c: 3 });
// actions.offGlobalStateChange();

export default function initMicroApp() {
    // 注册子应用
  registerMicroApps([
    {
      name: 'admin',            // 子应用名称
      entry: '//localhost:3001',  // 子应用入口
      container: '#container',    // 子应用所在容器
      activeRule: '/micro/admin',         // 子应用触发规则（路径）
    },
    {
      name: 'suppiler',            // 子应用名称
      entry: '//localhost:3002',  // 子应用入口
      container: '#container',    // 子应用所在容器
      activeRule: '/micro/supplier',         // 子应用触发规则（路径）
    },
  ],
  {
    beforeLoad: (app) => console.info('before load', app.name),
    beforeMount: [(app) => console.info('before mount', app.name)],
  },
  );

  // 启动默认应用
  setDefaultMountApp('/micro/admin');

  start();
}
