import React from 'react';
import ReactDOM from 'react-dom/client';
import { renderWithQiankun, qiankunWindow } from 'vite-plugin-qiankun/dist/helper';

import App from './App';

import './public-path.js';

import './index.css';

function render(props = {}) {
  const root = ReactDOM.createRoot(props.container ? props.container.querySelector('#root') : document.getElementById('root'));
  root.render(
    // <React.StrictMode>
    <App />,
    // </React.StrictMode>
  );
}

// // 独立运行
// if (!window.__POWERED_BY_QIANKUN__) {
//   render();
// }

// // 生命周期
// export async function bootstrap() {
//   console.info('[supplier-app] bootstraped');
// }
// export async function mount(props) {
//   console.info('[supplier-app] props from main framework', props);
//   // storeTest(props);
//   render(props);
// }
// export async function unmount(props) {
//   console.info('[supplier-app] unmount');
//   ReactDOM.unmountComponentAtNode(
//     props.container ? props.container.querySelector('#root') : document.getElementById('root'),
//   );
// }

renderWithQiankun({
  mount(props) {
    console.info('[supplier-app] props from main framework', props);
    render(props);
    props.onGlobalStateChange((state, prev) => {
      // state: 变更后的状态; prev 变更前的状态
      console.info(state, prev);
    });

    props.setGlobalState({ a: 100, b: 200, d: 400 });
  },
  bootstrap() {
    console.info('[supplier-app] bootstraped');
  },
  unmount(props) {
    console.info('[supplier-app] unmount');
    ReactDOM.unmountComponentAtNode(
      props.container ? props.container.querySelector('#root') : document.getElementById('root'),
    );
  },
});

if (!qiankunWindow.__POWERED_BY_QIANKUN__) {
  render({});
}
